SystemOrganization addCategory: #'TP2-Parte3'!
SystemOrganization addCategory: #'TP2-Parte3-tests'!

Trait named: #TraitParaTest
	uses: {}
	category: 'TP2-Parte3-tests'!

!TraitParaTest methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 02:11'!
manejar: unNumero 
	^unNumero * 100.! !

TestCase subclass: #TestParte3
	instanceVariableNames: 'estrategiaDef estrategiaConCondicion estrategiaConFuncion refactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3-tests'!

!TestParte3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 02:17'!
setUp 
	
	estrategiaDef := EstrategiaDefault CrearEstrategiaDefault.
	estrategiaConCondicion := EstrategiaConCondicion CrearEstrategiaConCondicion: [ :x | x < 2 ].
	estrategiaConFuncion := EstrategiaConFuncion CrearEstrategiaConFuncion: [ :x | x + 20 ].
	refactor := refactor new.! !

!TestParte3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 02:18'!
tearDown 
	MetaUtil recreateCategory: 'Clase'.
	MetaUtil recreateCategory: 'TraitParaTest'.! !

!TestParte3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 02:19'!
testElRefactorAgregaElTrait 
	refactor agregarTrait: TraitParaTest a: Clase con: estrategiaDef.
	self assert: (Clase traits includes: TraitParaTest).! !

Object subclass: #Clase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3-tests'!

!Clase methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 02:09'!
manejar: unNumero 
	^unNumero + 1.! !

Object subclass: #EstrategiaBasica
	instanceVariableNames: 'funcion condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaBasica class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:06'!
CrearEstrategiaConCondicion: unaCondicion yFuncion: unaFuncion
	
	| nuevaEstrategia |
	
	nuevaEstrategia := EstrategiaBasica new.
	nuevaEstrategia condicion: unaCondicion.
	nuevaEstrategia funcion: unaFuncion.
	^nuevaEstrategia.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:57'!
aplicarFuncion: unValor 
	^funcion value: unValor.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:30'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:30'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:29'!
condicion
	^condicion ! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:56'!
condicion: unBloqueCondicion
	condicion := unBloqueCondicion  .! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:57'!
cumpleCondicion: unValor
	^condicion value: unValor.
	! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:57'!
ejecutarTodosLosMetodosDeTraitsCorrespondientesA: unMetodo dentroDe: unObjeto conUnValorInicial: unValor

			| conflictivos retorno  |
			
			conflictivos := ( self obtenerTraitsConflictivosEn: (unObjeto class) para: unMetodo). 
		
			retorno := conflictivos inject: unValor into: 
			[ :resultado :implementador | 
				(self cumpleCondicion: retorno) ifFalse: [^resultado].
				(unObjeto class) methodDict at: #auxiliar put: (implementador >> unMetodo) . 
				unObjeto perform: #auxiliar with: resultado 
			].
			(unObjeto class) methodDict at: #auxiliar put: nil.
		
			^self aplicarFuncion: retorno.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:29'!
funcion
	^funcion.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:56'!
funcion: unBloqueFuncion "Una funcion es un cdigo a compilar"
	funcion := unBloqueFuncion.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:30'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 02:22'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := self armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: ( (unaClase >> unMetodo ) getSourceReplacingSelectorWith: 'original',unMetodo ).
		
		unaClase addInstVarNamed: 'refactor'.
		
		unaClase compile: 
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			
			|  retorno |
			
			refactor := EstrategiaBasica CrearEstrategiaConCondicion: ', condicion asString ,' yFuncion: ', funcion asString ,'.
			
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := refactor ejecutarTodosLosMetodosDeTraitsCorrespondientesA: #',unMetodo,' dentroDe: self conUnValorInicial: retorno .
			
			^retorno.
			'
	].! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:31'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

EstrategiaBasica subclass: #EstrategiaConCondicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaConCondicion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:39'!
CrearEstrategiaConCondicion: unaCondicion
	^self superclass CrearEstrategiaConCondicion: unaCondicion yFuncion: [ :x | x ].! !

!EstrategiaConCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:23'!
CrearEstrategiaConCondicion: unaCondicion
	^self superclass CrearEstrategiaConCondicion: unaCondicion yFuncion: [ :x | x ].! !

EstrategiaBasica subclass: #EstrategiaConFuncion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaConFuncion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:24'!
CrearEstrategiaConFuncion: unaFuncion
	^EstrategiaBasica CrearEstrategiaConCondicion: [ :x | true ] yFuncion: unaFuncion.! !

EstrategiaBasica subclass: #EstrategiaDefault
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaDefault class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:20'!
CrearEstrategiaDefault
		^EstrategiaBasica CrearEstrategiaConCondicion: [ :x | true ] yFuncion: [ :x | x ]! !

Object subclass: #Refactor3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 17:49'!
agregarTrait: unTrait a: unaClase con: unaEstrategia
	
	|metodosConflictivos|
	
	( unaClase traits includes: unTrait ) ifFalse: 
	[
		unaClase addToComposition: unTrait.
	
		metodosConflictivos := unTrait selectors select: [ :selector | self esConflitivo: selector en: unaClase ].
	
		metodosConflictivos do: [ :selector | unaEstrategia resolverConflictoPara: selector entre: unTrait  y: unaClase ].
	]! !

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/2/2013 00:19'!
esConflitivo: unSelector en: unaClase
	|traits|
	
	traits := unaClase traits.
	
	^ (unaClase selectors includes: unSelector) | ( traits notEmpty and: [ traits anySatisfy: [ :unTrait | self esConflitivo: unSelector en: unTrait ] ] ). 
	
	"Mejorar TODO"! !
